> For the complete documentation index, see [llms.txt](https://docs.relevant-digital.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.relevant-digital.com/technical/integration/javascript-api/relevantdigital.loadvideourls.md).

# relevantDigital.loadVideoUrls()

Use `relevantDigital.loadVideoUrls()` to retrieve VAST XML URLs for instream video slots.

The function waits for the corresponding [relevantDigital.loadPrebid()](/technical/integration/javascript-api/relevantdigital.loadprebid.md) auction. It does not start an auction itself.

For a complete instream implementation, see [Instream video with HBM and GAM](/technical/integration/formats-and-channels/instream-video-with-hbm-and-gam.md).

### How it works

* You can call `loadVideoUrls()` before or after `loadPrebid()`.
* The callback runs only after the matching Prebid auction completes.
* For a single `loadPrebid()` call, only the first `loadVideoUrls()` call for the same slots completes.

{% hint style="info" %}
The VAST URLs returned by this API target Google Ad Manager.
{% endhint %}

### Parameters

#### `ids`

The IDs of `VideoSlot` objects created with [relevantDigital.defineVideoSlots()](/technical/integration/javascript-api/relevantdigital.definevideoslots.md). Use `videoSlot.getSlotElementId()` to retrieve a slot ID.

#### `cb(urls)`

The callback that receives VAST XML URLs. Pass these URLs to your video player.

#### `settings`

Optional settings.

**`onBuildVideoUrl`**

A callback that customizes the settings passed to [pbjs.adServers.gam.buildVideoUrl()](https://docs.prebid.org/dev-docs/publisher-api-reference/adServers.gam.buildVideoUrl.html). For Prebid.js versions before 10, it applies to [pbjs.adServers.dfp.buildVideoUrl()](https://docs.prebid.org/dev-docs/publisher-api-reference/adServers.dfp.buildVideoUrl.html).

### Example

```
window.relevantDigital = window.relevantDigital || {};
relevantDigital.cmd = relevantDigital.cmd || [];
relevantDigital.cmd.push(() => {
    const videoSlots = relevantDigital.defineVideoSlots([
        {
           path: '/12345/articles/pre_roll',
           id: 'preroll_1',
           custParams: { 'section': 'articles' },
        },
        {
           path: '/12345/articles/pre_roll',
           id: 'preroll_2',
           custParams: { 'section': 'articles' },
           },
    ]);
    

    // Call relevantDigital.loadPrebid() "as normal"
    relevantDigital.loadPrebid({ ... });
    
    // Get the URLs with VAST XML that should be used with the video player
    relevantDigital.loadVideoUrls(['preroll_1', 'preroll_2'], (vastUrls, datas) => {
       console.info('VAST URLs:', vastUrls);
       // TODO: Invoke video player here
    });
});
```

### Other ad servers

The returned `vastUrls` target Google Ad Manager. For another ad server, or for additional bid details, use the callback's `datas` parameter.

```
relevantDigital.loadVideoUrls(['preroll_1', 'preroll_2'], (vastUrls, datas) => {
    datas.forEach(({ unitData }) => {
         const highestBid = unitData.getHighestBid();
         if (highestBid) {
             console.info('Got bid for placement: ', unitData.slot.getAdUnitPath());
             console.info('Targeting key-values: ', highestBid.adserverTargeting);
             console.info('VAST URL: ', highestBid.vastUrl);
             console.info('VAST XML: ', highestBid.vastXml);

         } else {
             console.info('No bid for placement: ', unitData.slot.getAdUnitPath());
         }
    });
});
```

<br>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.relevant-digital.com/technical/integration/javascript-api/relevantdigital.loadvideourls.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
